//
//  Affine.cpp
//  MANITEST
//
//  Created by Alhussein Fawzi on 17.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#include "Affine.h"

cv::Mat Affine::transformFromWarpMat(cv::Mat warpMat) {
    
    // cv::Mat invWarpMat = invAfffineTransform(warpMat); // Improve
    cv::Mat invWarpMat;
    invertAffineTransform(warpMat, invWarpMat);
    
    // cout << "invWarpMat = " << invWarpMat << endl;
    
    cv::Mat trans(img->rows, img->cols, img->type());
    // cv::Mat x(3,1,CV_64F), x2(2,1,CV_64F);
    // double x2[3];
    double x; double y; int x1, x2, y1, y2;
    
    int i,j; double* p1 = invWarpMat.ptr<double>(0); double* p2 = invWarpMat.ptr<double>(1);
    double f11, f12, f21, f22;
    
    int cols = img->cols; int rows = img->rows;
    
    for (i=0;i<rows;i++) {
        for (j=0;j<cols;j++) {
            x = p1[0] * j + p1[1] * i + p1[2];
            y = p2[0] * j + p2[1] * i + p2[2];
            
            x1 = floor(x); x2 = x1+1;
            y1 = floor(y); y2 = y1+1;
            
            if (x1 < 0 || y1 < 0 || x2 > cols || y2 > rows) {
                (trans).at<double>(i,j) = 0;
                continue;
            }
            
            x = (x2 == cols) ? x1 : x;
            y = (y2 == rows) ? y1 : y;
            
            f11 = (img)->at<double>(y1,x1);
            f12 = (img)->at<double>(y2,x1);
            f21 = (img)->at<double>(y1,x2);
            f22 = (img)->at<double>(y2,x2);
            
            (trans).at<double>(i,j) = (f11 * (x2-x) * (y2-y) + f21 * (x-x1) * (y2-y) + f12 * (x2-x) * (y-y1) + f22 * (x-x1) * (y-y1));
        }
    }
    
    return trans;
}