//
//  Similarity.cpp
//  MANITEST
//
//  Created by Alhussein Fawzi on 17.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#include "Similarity.h"

cv::Mat Similarity::para2tfm(std::vector<double> para) {
    // assert(n_rows != -1 && n_cols != -1);
    int n_rows = (*img).rows; int n_cols = (*img).cols;
    cv::Point center = cv::Point( n_cols/2, n_rows/2 );
    cv::Mat tfm = cv::getRotationMatrix2D(center, para[3] * 180 / M_PI, para[2]);
    tfm.at<double>(0,2) += para[0];
    tfm.at<double>(1,2) += para[1];
    return tfm;
}

std::string Similarity::getName() {
    return("Similarity");
}

std::vector<double> Similarity::getDefaultDiscretization() {
    return std::vector<double> {0.5, 0.5, 0.1, M_PI/20};
}

std::vector<double> Similarity::getDefaultOffset() {
    return std::vector<double> {0, 0, 1, 0};
}
