//
//  Transformation.cpp
//  MANITEST
//
//  Created by Alhussein Fawzi on 17.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#include "Transformation.h"
#include "Affine.h"


cv::Mat Transformation::transformImage(std::vector<double> para) {
    return transformFromWarpMat(para2tfm(para));
}

void Transformation::setImage(cv::Mat _img) {
    this->img = &_img;
}

cv::Mat Transformation::jacobi(std::vector <double> para) {
    cv::Mat J((int) para.size(), img->cols*img->rows, (*img).type());
    cv::Mat diffMat;
    std::vector <double> p_eps;
    cv::Mat transf_imageOrig = transformImage(para);
    int i;
    
    for (i=0;i<para.size();i++) {
        p_eps = para; p_eps[i] += EPS;
        diffMat = (transformImage(p_eps) - transf_imageOrig) / EPS;
        diffMat.reshape(0,1).copyTo(J.row(i));
    }
    return J;
}