//
//  utils.cpp
//  MANITEST
//
//  Created by Alhussein Fawzi on 25.05.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#include "utils.h"

void showImage(std::string title, cv::Mat im) {
    // im is assumed to be float or double
    // Map everything to [0,1]
    double minValue, maxValue;
    
    minMaxLoc(im, &minValue, &maxValue);
    cv::Mat im2 = (im - minValue) / (maxValue - minValue);
    
    imshow(title, im2);
}

void subtractVec(std::vector<double>* a, std::vector<double>* b) {
    // Modify a
    assert(a->size() == b->size());
    int i;
    for (i=0; i<a->size(); i++) {
        (*a)[i] -= (*b)[i];
    }
}

double norm_sq_mat(cv::Mat A, cv::Mat b) {
    return b.dot(A*b);
}

double inner_product_mat(cv::Mat A, cv::Mat b, cv::Mat c) {
    return b.dot(A*c);
}

bool checkAllFalse(std::vector<bool> a) {
    for (int i=0; i<a.size(); i++) {
        if (a[i]) {
            return false;
        }
    }
    return true;
}